'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _defineProperty4 = require('babel-runtime/core-js/object/define-property');

var _defineProperty5 = _interopRequireDefault(_defineProperty4);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _symbol = require('babel-runtime/core-js/symbol');

var _symbol2 = _interopRequireDefault(_symbol);

var _mergeConfigs = require('../merge-configs');

var _mergeConfigs2 = _interopRequireDefault(_mergeConfigs);

var _graphCrdt = require('graph-crdt');

var _context4 = require('./context');

var _context5 = _interopRequireDefault(_context4);

var _pipeline = require('../pipeline');

var pipeline = _interopRequireWildcard(_pipeline);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var settings = (0, _symbol2.default)('database configuration');

/**
 * Plugin manager for graph-crdt.
 * @class Database
 */

var Database = function (_Graph) {
  (0, _inherits3.default)(Database, _Graph);

  /**
   * Instantiates a new graph database.
   * @param  {Object} config - A database configuration object.
   */
  function Database(config) {
    (0, _classCallCheck3.default)(this, Database);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Database.__proto__ || (0, _getPrototypeOf2.default)(Database)).call(this));

    _this[settings] = config;

    var createRouter = config.router;

    var router = createRouter ? createRouter(_this, config) : null;

    Object.defineProperty(_this, 'router', { value: router });

    var extensions = config.extend.root;

    /** Add API extensions from the config. */
    (0, _keys2.default)(extensions).forEach(function (key) {
      var value = extensions[key];

      /** Non-enumerable and immutable. */
      (0, _defineProperty5.default)(_this, key, { value: value });
    });
    return _this;
  }

  /**
   * Applies a collection of changes all at once.
   * @param  {Graph|Database} update - A collection of updates.
   * @param  {Object} [options] - Override global configuration.
   * @return {Promise} - Resolves when the commit has been processed.
   */


  (0, _createClass3.default)(Database, [{
    key: 'commit',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(update) {
        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        var graph, contexts, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _step$value, id, node, context, current, _current$meta, uid, config, writes, deltas;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:

                // Storage drivers get the full state of each node.
                graph = new _graphCrdt.Graph();
                contexts = this.new();
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context.prev = 5;


                for (_iterator = (0, _getIterator3.default)(update); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                  _step$value = (0, _slicedToArray3.default)(_step.value, 1), id = _step$value[0];
                  node = update.value(id);


                  if (node instanceof _context5.default) {
                    contexts.merge((0, _defineProperty3.default)({}, id, node));
                  } else {
                    context = new _context5.default(this, { uid: id });

                    context.merge(node);
                    contexts.merge((0, _defineProperty3.default)({}, id, context));
                  }

                  // If the node exists in the graph...
                  current = this.value(id);


                  if (current) {
                    _current$meta = current.meta(), uid = _current$meta.uid;

                    // Merge it with the update.

                    graph.merge((0, _defineProperty3.default)({}, uid, current));
                  }
                }

                _context.next = 13;
                break;

              case 9:
                _context.prev = 9;
                _context.t0 = _context['catch'](5);
                _didIteratorError = true;
                _iteratorError = _context.t0;

              case 13:
                _context.prev = 13;
                _context.prev = 14;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 16:
                _context.prev = 16;

                if (!_didIteratorError) {
                  _context.next = 19;
                  break;
                }

                throw _iteratorError;

              case 19:
                return _context.finish(16);

              case 20:
                return _context.finish(13);

              case 21:
                graph.merge(update);

                _context.next = 24;
                return pipeline.before.write(this[settings], (0, _extends3.default)({}, options, {
                  update: update,
                  graph: graph
                }));

              case 24:
                config = _context.sent;


                // Persist.
                writes = config.storage.map(function (store) {
                  return store.write(config);
                });

                if (!this.router) {
                  _context.next = 29;
                  break;
                }

                _context.next = 29;
                return this.router.push(config);

              case 29:
                _context.next = 31;
                return _promise2.default.all(writes);

              case 31:

                // Merge in the update.
                deltas = this.merge(contexts);
                _context.next = 34;
                return pipeline.after.write(this[settings], (0, _extends3.default)({}, config, deltas));

              case 34:
                return _context.abrupt('return', _context.sent);

              case 35:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[5, 9, 13, 21], [14,, 16, 20]]);
      }));

      function commit(_x, _x2) {
        return _ref.apply(this, arguments);
      }

      return commit;
    }()

    /**
     * Merges a node into the graph.
     * @param  {String} uid - The unique ID of the node.
     * @param  {Object} value - The fields to add/update.
     * @param  {Object} [options] - Override default behavior.
     * @return {Context} - Resolves to the context written.
     */

  }, {
    key: 'write',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(uid, value) {
        var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
        var context, current, field, update;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:

                // Turn the object into a database context.
                context = new _context5.default(this, { uid: uid });
                current = this.value(uid);

                // Ensure object updates increment state.

                if (current && value) {
                  for (field in value) {
                    if (value.hasOwnProperty(field)) {
                      context.merge((0, _defineProperty3.default)({}, field, current.value(field)));
                      context.meta(field).state = current.state(field);
                    }
                  }
                }

                context.merge(value);

                update = _graphCrdt.Graph.source((0, _defineProperty3.default)({}, uid, context));
                _context2.next = 7;
                return this.commit(update, options);

              case 7:
                return _context2.abrupt('return', this.value(uid));

              case 8:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function write(_x4, _x5, _x6) {
        return _ref2.apply(this, arguments);
      }

      return write;
    }()

    /**
     * Read a context from the database.
     * @param  {String} key - The node's unique ID.
     * @param  {Object} [options] - Plugin-level options.
     * @return {Context|null} - Resolves to the node.
     */

  }, {
    key: 'read',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(key) {
        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        var config, params, node, reads, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, _result, update, result;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                config = this[settings];
                _context3.next = 3;
                return pipeline.before.read.node(config, (0, _extends3.default)({}, options, {
                  key: key
                }));

              case 3:
                params = _context3.sent;
                node = this.value(params.key);

                // Not cached.

                if (!(node === null)) {
                  _context3.next = 38;
                  break;
                }

                // Ask the storage plugins for it.
                reads = [].concat((0, _toConsumableArray3.default)(params.storage)).map(function (store) {
                  return store.read(params);
                });

                // Ask the network for it.

                if (this.router) {
                  reads.push(this.router.pull(params));
                }

                _iteratorNormalCompletion2 = true;
                _didIteratorError2 = false;
                _iteratorError2 = undefined;
                _context3.prev = 11;
                _context3.next = 14;
                return _promise2.default.all(reads);

              case 14:
                _context3.t0 = _context3.sent;
                _iterator2 = (0, _getIterator3.default)(_context3.t0);

              case 16:
                if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                  _context3.next = 23;
                  break;
                }

                _result = _step2.value;
                update = _graphCrdt.Node.source(_result);


                if (_result) {
                  node = node || new _context5.default(this, { uid: params.key });
                  node.merge(update);
                }

              case 20:
                _iteratorNormalCompletion2 = true;
                _context3.next = 16;
                break;

              case 23:
                _context3.next = 29;
                break;

              case 25:
                _context3.prev = 25;
                _context3.t1 = _context3['catch'](11);
                _didIteratorError2 = true;
                _iteratorError2 = _context3.t1;

              case 29:
                _context3.prev = 29;
                _context3.prev = 30;

                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                  _iterator2.return();
                }

              case 32:
                _context3.prev = 32;

                if (!_didIteratorError2) {
                  _context3.next = 35;
                  break;
                }

                throw _iteratorError2;

              case 35:
                return _context3.finish(32);

              case 36:
                return _context3.finish(29);

              case 37:

                /** Cache the value. */
                if (node) {
                  this.merge((0, _defineProperty3.default)({}, params.key, node));
                }

              case 38:
                _context3.next = 40;
                return pipeline.after.read.node(config, (0, _extends3.default)({}, params, {
                  context: this.value(params.key)
                }));

              case 40:
                result = _context3.sent;
                return _context3.abrupt('return', result.context);

              case 42:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this, [[11, 25, 29, 37], [30,, 32, 36]]);
      }));

      function read(_x8, _x9) {
        return _ref3.apply(this, arguments);
      }

      return read;
    }()

    /**
     * description
     * @param  {Mixed} query - query that is passed to the engine
     * @param  {Object} options - options for executing the query
     * @return {undefined}
     */

  }, {
    key: 'query',
    value: function query(_query, options) {

      var config = this[settings];
      var engines = config.engines;
      var engine = options.engine;

      // Make sure the engine exists
      if (!engines.hasOwnProperty(engine)) {
        throw new Error('No engine is defined in options');
      }

      var queryEngine = engines[engine];
      return queryEngine.executeQuery(_query, this);
    }
  }]);
  return Database;
}(_graphCrdt.Graph);

/**
 * Creates a new instance of `Database` with or without `new`.
 * @param  {...Object} configs - Plugins and configurations for the database.
 * @return {Database} - A new database instance.
 */


function database() {
  for (var _len = arguments.length, configs = Array(_len), _key = 0; _key < _len; _key++) {
    configs[_key] = arguments[_key];
  }

  var config = (0, _mergeConfigs2.default)(configs);

  return new Database(config);
}

database.configuration = settings;

exports.default = database;