'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.queryEngine = exports.createRouter = exports.Router = exports.Connection = exports.Storage = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _expect = require('expect');

var _stream = require('./stream');

var _stream2 = _interopRequireDefault(_stream);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable require-jsdoc */
var Storage = exports.Storage = function () {
  function Storage() {
    (0, _classCallCheck3.default)(this, Storage);
    this.cache = {};
  }

  (0, _createClass3.default)(Storage, [{
    key: 'write',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
        var graph = _ref2.graph;

        var cache, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _step$value, uid, node;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                cache = this.cache;
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context.prev = 4;


                for (_iterator = (0, _getIterator3.default)(graph); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                  _step$value = (0, _slicedToArray3.default)(_step.value, 2), uid = _step$value[0], node = _step$value[1];

                  cache[uid] = (0, _stringify2.default)(node);
                }
                _context.next = 12;
                break;

              case 8:
                _context.prev = 8;
                _context.t0 = _context['catch'](4);
                _didIteratorError = true;
                _iteratorError = _context.t0;

              case 12:
                _context.prev = 12;
                _context.prev = 13;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 15:
                _context.prev = 15;

                if (!_didIteratorError) {
                  _context.next = 18;
                  break;
                }

                throw _iteratorError;

              case 18:
                return _context.finish(15);

              case 19:
                return _context.finish(12);

              case 20:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[4, 8, 12, 20], [13,, 15, 19]]);
      }));

      function write(_x) {
        return _ref.apply(this, arguments);
      }

      return write;
    }()
  }, {
    key: 'read',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_ref4) {
        var key = _ref4.key;
        var value;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                value = this.cache[key];
                return _context2.abrupt('return', value && JSON.parse(value));

              case 2:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function read(_x2) {
        return _ref3.apply(this, arguments);
      }

      return read;
    }()
  }]);
  return Storage;
}();

var Connection = exports.Connection = function Connection() {
  var _this = this;

  var _ref5 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref5$id = _ref5.id,
      id = _ref5$id === undefined ? 'default-connection-id' : _ref5$id,
      _ref5$type = _ref5.type,
      type = _ref5$type === undefined ? 'mock' : _ref5$type;

  (0, _classCallCheck3.default)(this, Connection);
  this.send = (0, _expect.createSpy)();
  this.messages = new _stream2.default(function (push, complete) {
    _this.complete = complete;
    _this.push = push;
  });

  this.type = type;
  this.id = id;
};

var Router = exports.Router = function Router() {
  (0, _classCallCheck3.default)(this, Router);
  this.push = (0, _expect.createSpy)().andReturn(_promise2.default.resolve());
  this.pull = (0, _expect.createSpy)().andReturn(_promise2.default.resolve());
};

var createRouter = exports.createRouter = (0, _expect.createSpy)().andCall(function () {
  return new Router();
});

var queryEngine = exports.queryEngine = {
  executeQuery: function executeQuery() {}
};