'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

var _expect = require('expect');

var _expect2 = _interopRequireDefault(_expect);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-env mocha*/
describe('A trigger', function () {

  it('should return a promise', function () {
    var result = (0, _index2.default)({
      transform: function transform() {},

      initial: {},
      hooks: []
    });

    (0, _expect2.default)(result).toBeA(_promise2.default);
  });

  it('should call the hooks', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    var spy;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            spy = (0, _expect.createSpy)();

            spy.andReturn(_promise2.default.resolve());

            _context.next = 4;
            return (0, _index2.default)({
              transform: function transform() {},

              hooks: [spy],
              initial: {}
            });

          case 4:

            (0, _expect2.default)(spy).toHaveBeenCalled();

          case 5:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  })));

  it('should pass arguments', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
    var spy, initial;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            spy = (0, _expect.createSpy)();

            spy.andReturn(_promise2.default.resolve());
            initial = { data: 'nope' };
            _context2.next = 5;
            return (0, _index2.default)({
              transform: function transform() {},

              hooks: [spy],
              initial: initial
            });

          case 5:

            (0, _expect2.default)(spy).toHaveBeenCalledWith(initial);

          case 6:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  })));

  it('should apply the `this` context to each hook', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
    var spy, context;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            spy = (0, _expect.createSpy)();

            spy.andReturn(_promise2.default.resolve());
            context = { '`this` context test': true };
            _context3.next = 5;
            return _index2.default.call(context, {
              transform: function transform() {},

              hooks: [spy],
              initial: {}
            });

          case 5:

            (0, _expect2.default)(spy.calls[0].context).toBe(context);

          case 6:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  })));

  it('should run `transform` after each hook', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5() {
    var spy;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            spy = (0, _expect.createSpy)();
            _context5.next = 3;
            return (0, _index2.default)({
              hooks: [(0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
                return _regenerator2.default.wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        return _context4.abrupt('return', 'fake result');

                      case 1:
                      case 'end':
                        return _context4.stop();
                    }
                  }
                }, _callee4, undefined);
              }))],
              initial: { initial: 'state' },
              transform: spy
            });

          case 3:

            (0, _expect2.default)(spy).toHaveBeenCalled();
            (0, _expect2.default)(spy).toHaveBeenCalledWith('fake result', { initial: 'state' });

          case 5:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, undefined);
  })));

  it('should send the transformed value to the next hook', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7() {
    var spy;
    return _regenerator2.default.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            spy = (0, _expect.createSpy)();

            spy.andReturn(_promise2.default.resolve('nope'));

            _context7.next = 4;
            return (0, _index2.default)({
              transform: function transform(result) {
                return result.replace(/first/, 'second');
              },
              initial: 'initial',
              hooks: [(0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6() {
                return _regenerator2.default.wrap(function _callee6$(_context6) {
                  while (1) {
                    switch (_context6.prev = _context6.next) {
                      case 0:
                        return _context6.abrupt('return', 'first hook value');

                      case 1:
                      case 'end':
                        return _context6.stop();
                    }
                  }
                }, _callee6, undefined);
              })), spy]
            });

          case 4:

            (0, _expect2.default)(spy).toHaveBeenCalledWith('second hook value');

          case 5:
          case 'end':
            return _context7.stop();
        }
      }
    }, _callee7, undefined);
  })));

  it('should return the final transformed args', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10() {
    var spy, value;
    return _regenerator2.default.wrap(function _callee10$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            spy = (0, _expect.createSpy)();

            spy.andReturn(_promise2.default.resolve());

            _context10.next = 4;
            return (0, _index2.default)({
              transform: function transform(output) {
                return output;
              },
              initial: 0,
              hooks: [function () {
                var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(val) {
                  return _regenerator2.default.wrap(function _callee8$(_context8) {
                    while (1) {
                      switch (_context8.prev = _context8.next) {
                        case 0:
                          return _context8.abrupt('return', val + 1);

                        case 1:
                        case 'end':
                          return _context8.stop();
                      }
                    }
                  }, _callee8, undefined);
                }));

                return function (_x) {
                  return _ref9.apply(this, arguments);
                };
              }(), function () {
                var _ref10 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9(val) {
                  return _regenerator2.default.wrap(function _callee9$(_context9) {
                    while (1) {
                      switch (_context9.prev = _context9.next) {
                        case 0:
                          return _context9.abrupt('return', val + 1);

                        case 1:
                        case 'end':
                          return _context9.stop();
                      }
                    }
                  }, _callee9, undefined);
                }));

                return function (_x2) {
                  return _ref10.apply(this, arguments);
                };
              }()]
            });

          case 4:
            value = _context10.sent;


            (0, _expect2.default)(value).toEqual(2);

          case 6:
          case 'end':
            return _context10.stop();
        }
      }
    }, _callee10, undefined);
  })));

  it('should work for synchronous hooks', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee12() {
    var value;
    return _regenerator2.default.wrap(function _callee12$(_context12) {
      while (1) {
        switch (_context12.prev = _context12.next) {
          case 0:
            _context12.next = 2;
            return (0, _index2.default)({
              transform: function transform(output) {
                return output;
              },
              initial: 0,
              hooks: [function () {
                var _ref12 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee11(num) {
                  return _regenerator2.default.wrap(function _callee11$(_context11) {
                    while (1) {
                      switch (_context11.prev = _context11.next) {
                        case 0:
                          return _context11.abrupt('return', num + 2);

                        case 1:
                        case 'end':
                          return _context11.stop();
                      }
                    }
                  }, _callee11, undefined);
                }));

                return function (_x3) {
                  return _ref12.apply(this, arguments);
                };
              }(), function (num) {
                return num + 2;
              }]
            });

          case 2:
            value = _context12.sent;


            (0, _expect2.default)(value).toEqual(4);

          case 4:
          case 'end':
            return _context12.stop();
        }
      }
    }, _callee12, undefined);
  })));
});